// *-*-c++-*-* Emacs/c++-mode

#include "ZZX.h"
#include <NTL/new.h>

NTL_START_IMPL

// taken from NTL/ZZX1.c
static
long MaxSize(const ZZX& a)
{
   long res = 0;
   long n = a.rep.length();

   long i;
   for (i = 0; i < n; i++) {
      long t = a.rep[i].size();
      if (t > res)
         res = t;
   }

   return res;
}
// end of copy pasted functions


// user level transposed multiplication
void tmul(ZZX& b, long db, const ZZX& a, const ZZX& c)
{
  long da = deg(a);
  long dc = deg(c);

  if ((da >= 0 && dc > da + db) || (da < 0 && dc >= 0))
    Error("tmul/ZZX: bad args");
 
  if (da < 0) {
    clear(b);
    return;
  }
  
  long maxa = MaxSize(a);
  long maxc = MaxSize(c);
  
  long k = min(maxa, maxc);
  long s = min(deg(a), deg(c)-deg(b)) + 1;
  
  if (s == 1 || (k == 1 && s < 40) || (k == 2 && s < 20) || 
      (k == 3 && s < 10)) {
    
    TPlainMul(b, db, a, c);
    return;
  }
  
  if (s < 80 || (k < 30 && s < 150))  {
    TKarMul(b, db, a, c);
    return;
  }
  //TODO
  if (maxa + maxc >= 40 && 
      SSRatio(deg(a), MaxBits(a), deg(b), MaxBits(b)) < 1.75) {
    // TSSMul(b, a, c);
    Error("tmul/ZZX1: not implemented yet");
  }
  else {
    // THomMul(b, a, c);
    Error("tmul/ZZX1: not implemented yet");
  }
}

NTL_END_IMPL
