#ifndef NTL_ZZ_pX_T__H
#define NTL_ZZ_pX_T__H


#include <NTL/ZZ_p.h>
#include <NTL/ZZ_pX.h>
#include "vec_vec_ZZ_pX.h"


NTL_OPEN_NNS

void TPlainMul(ZZ_pX& x, long dx, const ZZ_pX& a, const ZZ_pX& b);
void TFFTMul(ZZ_pX& x, long dx, const ZZ_pX& b, const ZZ_pX& a);
void tmul(ZZ_pX& c, long dc, const ZZ_pX& a, const ZZ_pX& b);

void TPlainDivRem(ZZ_pX& b, long db, const ZZ_pX& a, const ZZ_pX& q, const ZZ_pX& r);
void TPlainDiv(ZZ_pX& b, long db, const ZZ_pX& a, const ZZ_pX& q);
void TPlainRem(ZZ_pX& b, long db, const ZZ_pX& a, const ZZ_pX& r);

void TFFTDivRem(ZZ_pX& b, long db, const ZZ_pX& a, const ZZ_pX& q, const ZZ_pX& r);
void TFFTRem(ZZ_pX& b, long db, const ZZ_pX& a, const ZZ_pX& r);
void TFFTDiv(ZZ_pX& b, long db, const ZZ_pX& a, const ZZ_pX& q);

void TDivRem(ZZ_pX& b, long db, const ZZ_pX& a, const ZZ_pX& q, const ZZ_pX& r);
void tdiv(ZZ_pX& b, long db, const ZZ_pX& a, const ZZ_pX& q);
void trem(ZZ_pX& b, long db, const ZZ_pX& a, const ZZ_pX& r);

void TMulMod(ZZ_pX& b, const ZZ_pX& a, const ZZ_pX& x, const ZZ_pX& f);

/*
 * Evaluation
 */

// TODO << introduce crossover points
void PlainEval(ZZ_p& b, const ZZ_pX& f, const ZZ_p& a);
void PlainEval(vec_ZZ_p& b, const ZZ_pX& f, const vec_ZZ_p& a);

void TPlainEval(ZZ_pX& f, long d, const ZZ_p& b, const ZZ_p& a);
void TPlainEval(ZZ_pX& f, long d, const vec_ZZ_p& b, const vec_ZZ_p& a);

void Fast1Eval(vec_ZZ_p& y, const ZZ_pX& a, const vec_ZZ_p& x, const vec_vec_ZZ_pX& tree);
void Fast1Eval(vec_ZZ_p& y, const ZZ_pX& a, const vec_ZZ_p& x);

void TFast1Eval(ZZ_pX& a, long da, const vec_ZZ_p& y, const vec_ZZ_p& x, const vec_vec_ZZ_pX& tree);
void TFast1Eval(ZZ_pX& a, long da, const vec_ZZ_p& y, const vec_ZZ_p& x);

void NewtonInvTruncMul(ZZ_pX& x, const ZZ_pX& a, long m, const ZZ_pX b);
// Should belong to some NTL's include file???
void CopyReverse(ZZ_pX& x, const ZZ_pX& a, long lo, long hi);

void Fast2Eval(vec_ZZ_p& y, const ZZ_pX& a, const vec_ZZ_p& x, const vec_vec_ZZ_pX& tree);
void Fast2Eval(vec_ZZ_p& y, const ZZ_pX& a, const vec_ZZ_p& x);

void TFast2Eval(ZZ_pX& f, long a, const vec_ZZ_p& y, const vec_ZZ_p& x, const vec_vec_ZZ_pX& tree);
void TFast2Eval(ZZ_pX& f, long a, const vec_ZZ_p& y, const vec_ZZ_p& x);

/*
 * Interpolation
 */

void PlainInterp(ZZ_pX& f, const vec_ZZ_p& a, const vec_ZZ_p& b);
void TPlainInterp(vec_ZZ_p& b, const vec_ZZ_p& a, const ZZ_pX& f);

void FastInterp(ZZ_pX& f, const vec_ZZ_p& x, const vec_ZZ_p& y, const vec_vec_ZZ_pX& tree);
void FastInterp(ZZ_pX& f, const vec_ZZ_p& x, const vec_ZZ_p& y);

void TFastInterp(vec_ZZ_p& y, const vec_ZZ_p& x, const ZZ_pX& f, const vec_vec_ZZ_pX& tree);
void TFastInterp(vec_ZZ_p& y, const vec_ZZ_p& x, const ZZ_pX& f);
NTL_CLOSE_NNS

#endif
